<template>
    <ul class="hackathon-list">
      <li class="error" v-if="!list || list.length == 0">Não há hackathons ainda :'(</li>
      <li v-for="item in list" :key="item.id" class="hackathon">
        <div class="hackathon-title">
          {{ item.name }} - {{ item.editions[0].name }}
        </div>
        <div class="hackathon-theme">
          {{ item.editions[0].theme }}
        </div>
        <div class="hackathon-date">
          {{ processDate(item.editions[0].date_start) }}
        </div>
        <div class="hackathon-registration">
          Inscrições de
          {{ processDate(item.editions[0].registration_start) }} a
          {{ processDate(item.editions[0].registration_end) }}
        </div>
      </li>
    </ul>
</template>

<script>
import gql from 'graphql-tag';

export default {
  computed: {
    list() {
      return this.hackathonsAfterDate;
    }
  },

  apollo: {
    hackathonsAfterDate() {
      const today = new Date();
      return {
        query: gql`
          query($day: Int!, $month: Int!, $year: Int!) {
            hackathonsAfterDate(
              start: { day: $day, month: $month, year: $year }
              count: 10
            ) {
              name
              editions {
                name
                date_start {
                  day
                  month
                  year
                }
                registration_start {
                  day
                  month
                  year
                }
                registration_end {
                  day
                  month
                  year
                }
              }
            }
          }
        `,
        variables: {
          day: today.getDate(),
          month: today.getMonth() + 1,
          year: today.getFullYear()
        }
      };
    }
  },

  methods: {
    processDate({ day, month, year }) {
      const date = new Date(`${year}/${month}/${day}`);
      return date.toLocaleDateString('pt-BR');
    }
  }
};
</script>

<style lang="scss">
$space-between: 0.5rem;
$header-font-size: 1.3rem;

.hackathon-list {
  display: flex;
  flex-flow: column nowrap;

  padding: $space-between 0.75rem;

  background: #6a5ace;

  height: 100%;
  width: 100%;

  list-style-type: none;
}

.hackathon {
  display: grid;
  grid-template-columns: 2fr 1fr;
  grid-template-rows: 2fr 1fr;
  grid-template-areas:
    'title date'
    'theme registration';
  justify-items: start;
  align-items: center;

  margin: $space-between;
  border-radius: 0.15rem;
  padding: 0.5rem;

  background: #fff;
}

.hackathon-title {
  grid-area: title;

  font-size: $header-font-size;
}

.hackathon-theme {
  grid-area: theme;
}

.hackathon-date {
  grid-area: date;

  font-size: $header-font-size;
}

.hackathon-registration {
  grid-area: registration;
}

.error {
  color: #fff;
  font-size: 1.4rem;
}
</style>
